


library(expm)

s = 5
a = 1
m = 0.05
t = 1

Q = matrix(c(0, a, 0, 0, -(a+2*(s-1)*m), 2*m, 0, 2*(s-1)*m, -2*m), nrow=3, ncol=3)
E = expm(Q*t)

x = m * s + a/2
y = 0.5 * sqrt(4*x^2 - 8 *a*m)
xsuby =  x - y
xaddy =  x + y
R2Given2 = (0.5 / y) * exp(-xsuby*t) * ((2*m - xsuby) + (xaddy - 2*m)*exp(-2*y*t))
R3Given2 = ( s - 1) * (m / y) * exp(-xsuby*t) * (1.0 - exp(-2*y*t))
R3Given3 = (0.5/y) * exp(-xsuby*t) * ((xaddy - 2*m) + (2*m - xsuby) * exp(-2*y*t));
R2Given3 = (m / y) * exp(-xsuby*t) * (1.0 - exp(-2*y*t))
print(E)
print(matrix(c(R2Given2,R2Given3,R3Given2,R3Given3), nrow=2, ncol=2))

